/*
 * BubsyMOD source code - audio_mixer.h
 * This application is open source and can be freely distributed
 * and modified, just leave credits to 8bitbubsy and mukunda.
 *
 * audio_mixer.c written by mukunda and 8bitbubsy
 * bubsymod.c written by 8bitbubsy
 * pattern_viewer.c written by 8bitbubsy
 * protracker_loader.c written by 8bitbubsy
 * protracker_sequencer.c written by mukunda and 8bitbubsy
 * sample_viewer.c written by 8bitbubsy
 * textout.c written by 8bitbubsy
 * volume.c written by 8bitbubsy
 *
 */

#ifndef __AUDIO_MIXER_H
#define __AUDIO_MIXER_H

/* fractional precision, code taken from ScummVM (/common/frac.h) */
#define FRAC_BITS 14
#define intToFrac(x) (unsigned int)((x) << FRAC_BITS)
#define fracToInt(x) (unsigned int)((x) >> FRAC_BITS)
#define doubleToFrac(x) (unsigned int)((x) * (1L << FRAC_BITS))
/* -------------------------------------------------------------- */

void audioCutAllVoices();
void audioChangeSrc(int ch, const char *src, unsigned int len, unsigned int loop_pos, unsigned int loop_len);
void audioSetSource(int ch, const char *src, unsigned int len, unsigned int loop_pos, unsigned int loop_len);
void audioSetOffset(int ch, unsigned int pos);
void audioSetVolume(int ch, int vol);
void audioSetRate(int ch, unsigned int freq);

int audioStart();
void audioStop();

typedef struct
{
	const char *data;      /* voice data     - -128 to 127   -  8 bits */
	unsigned char vol;      /* voice volume   -  0   to 64    -  7 bits */
	unsigned int panL;     /* voice panning  -  0   to 255   -  8 bits */
	unsigned int panR;     /* voice panning  -  0   to 255   -  8 bits */
	unsigned int rate;     /* voice inc rate -  0   to 65535 - 16 bits */
	unsigned int len;      /* voice read len -  0   to 65535 - 16 bits */
	unsigned int loop_len; /* voice loop len -  0   to 65535 - 16 bits */
	unsigned int loop_end; /* voice loop end -  0   to 65535 - 16 bits */

	unsigned int   pos;      /* voice position */
} Voice;

Voice v[4];

#endif

