/*
 * BubsyMOD source code - sample_viewer.c
 * This application is open source and can be freely distributed
 * and modified, just leave credits to 8bitbubsy and mukunda.
 *
 * audio_mixer.c written by mukunda and 8bitbubsy
 * bubsymod.c written by 8bitbubsy
 * pattern_viewer.c written by 8bitbubsy
 * protracker_loader.c written by 8bitbubsy
 * protracker_sequencer.c written by mukunda and 8bitbubsy
 * sample_viewer.c written by 8bitbubsy
 * textout.c written by 8bitbubsy
 * volume.c written by 8bitbubsy
 *
 */

#include <stdio.h>
#include <SDL/SDL.h>
#include "bubsymod.h"
#include "textout.h"
#include "audio_mixer.h"

int colindex = 0, c = 0;
int colindex2 = 0, c2 = 0;
static const int coltab[768];

void drawQuadrascopes(SDL_Surface *screen, MODULE *source)
{
	char pTmp[256];
	int i;
	unsigned short *p = (unsigned short *)screen->pixels;

	/* clear surface */
	SDL_FillRect(screen, NULL, 0x0000);

	sprintf(pTmp, "Now Playing: %s", source->head.module_title);
	textOut(screen, 4, 0, pTmp, 0xFFFF, 0, 0);
		
	sprintf(pTmp, "#%03d/%03d - %03dbpm (%02d ticks)", source->cur_order,
	source->head.order_count, source->cur_bpm, source->cur_speed);
	textOut(screen, 4, 10, pTmp, 0xFFFF, 0, 0);

	for (i = 0; i < 4; i++)
	{
		int _x = 32;

		int s;
		for (s = 0; s < (320 - 64); s++)
		{
			int _y = 37 + (i * 55);

			if (v[i].data != NULL)
			{
				unsigned int fracPos = (v[i].pos >> 14) + s;

				if (fracPos >= v[i].loop_end)
					fracPos -= v[i].loop_len;

				if (fracPos < v[i].len)
					_y += ((~v[i].data[fracPos] * (v[i].vol )) >> 8);
			}


			if (_y < 0) _y = 0;
			else if (_y >= 239) _y = 239;

			p[_y * 320 + (_x + s)] = coltab[((s + i) + colindex2) % 768];
		}

		if ((++c2 % 26) == 25)
		{
			c2 = 0;
				
			colindex2 += 2;
			if (colindex2 >= 768)
				colindex2 = 0;
		}
	}

	/* flip the backbuffer onto the framebuffer */
	SDL_UpdateRect(screen, 0, 0, 0, 0);

	return;
}

void drawSampleViewer(SDL_Surface *screen, MODULE *source)
{
	char pTmp[256];

	/* clear surface */
	SDL_FillRect(screen, NULL, 0x0000);

	sprintf(pTmp, "Now Playing: %s", source->head.module_title);
	textOut(screen, 4, 0, pTmp, 0xFFFF, 0, 0);
		
	sprintf(pTmp, "#%03d/%03d - %03dbpm (%02d ticks)", source->cur_order,
	source->head.order_count, source->cur_bpm, source->cur_speed);
	textOut(screen, 4, 10, pTmp, 0xFFFF, 0, 0);

	{
		int i;
		for (i = 0; i < 31; i++)
		{
			MODULE_SAMPLE *s = &source->samples[i];
			if (s->volbar_hit > 0)
			{
				int j;
				for (j = s->volbar_hit; j; j--)
					textOut(screen, (i * 8), 240 - (j * 8), "#", coltab[((i * 10) + colindex) % 768], 0, 0);
			}

			if ((++c % 32) == 0)
			{
				c = 0;
				
				colindex += 2;
				if (colindex >= 768)
					colindex = 0;
			}
		}
	}

	/* flip the backbuffer onto the framebuffer */
	SDL_UpdateRect(screen, 0, 0, 0, 0);

	return;
}

static const int coltab[768] = 
{
	0x8000, 0x8000, 0x8000, 0x8020, 0x8020, 0x8020, 0x8020, 0x8040, 0x8040, 
	0x8040, 0x8040, 0x8060, 0x8060, 0x8060, 0x8060, 0x8080, 0x8080, 0x8080, 
	0x8080, 0x80A0, 0x80A0, 0x80A0, 0x80A0, 0x80C0, 0x80C0, 0x80C0, 0x80C0, 
	0x80E0, 0x80E0, 0x80E0, 0x80E0, 0x8100, 0x8100, 0x8100, 0x8100, 0x8120, 
	0x8120, 0x8120, 0x8120, 0x8140, 0x8140, 0x8140, 0x8140, 0x8160, 0x8160, 
	0x8160, 0x8160, 0x8180, 0x8180, 0x8180, 0x8180, 0x81A0, 0x81A0, 0x81A0, 
	0x81A0, 0x81C0, 0x81C0, 0x81C0, 0x81C0, 0x81E0, 0x81E0, 0x81E0, 0x81E0, 
	0x8200, 0x8200, 0x8200, 0x8200, 0x8220, 0x8220, 0x8220, 0x8220, 0x8240, 
	0x8240, 0x8240, 0x8240, 0x8260, 0x8260, 0x8260, 0x8260, 0x8280, 0x8280, 
	0x8280, 0x8280, 0x82A0, 0x82A0, 0x82A0, 0x82A0, 0x82C0, 0x82C0, 0x82C0, 
	0x82C0, 0x82E0, 0x82E0, 0x82E0, 0x82E0, 0x8300, 0x8300, 0x8300, 0x8300, 
	0x8320, 0x8320, 0x8320, 0x8320, 0x8340, 0x8340, 0x8340, 0x8340, 0x8360, 
	0x8360, 0x8360, 0x8360, 0x8380, 0x8380, 0x8380, 0x8380, 0x83A0, 0x83A0, 
	0x83A0, 0x83A0, 0x83C0, 0x83C0, 0x83C0, 0x83C0, 0x83E0, 0x83E0, 0x83E0, 
	0x83E0, 0x8400, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 
	0x7C00, 0x7400, 0x7400, 0x7400, 0x7400, 0x7400, 0x7400, 0x7400, 0x7400, 
	0x6C00, 0x6C00, 0x6C00, 0x6C00, 0x6C00, 0x6C00, 0x6C00, 0x6C00, 0x6400, 
	0x6400, 0x6400, 0x6400, 0x6400, 0x6400, 0x6400, 0x6400, 0x5C00, 0x5C00, 
	0x5C00, 0x5C00, 0x5C00, 0x5C00, 0x5C00, 0x5C00, 0x5400, 0x5400, 0x5400, 
	0x5400, 0x5400, 0x5400, 0x5400, 0x5400, 0x4C00, 0x4C00, 0x4C00, 0x4C00, 
	0x4C00, 0x4C00, 0x4C00, 0x4C00, 0x4400, 0x4400, 0x4400, 0x4400, 0x4400, 
	0x4400, 0x4400, 0x4400, 0x3C00, 0x3C00, 0x3C00, 0x3C00, 0x3C00, 0x3C00, 
	0x3C00, 0x3C00, 0x3400, 0x3400, 0x3400, 0x3400, 0x3400, 0x3400, 0x3400, 
	0x3400, 0x2C00, 0x2C00, 0x2C00, 0x2C00, 0x2C00, 0x2C00, 0x2C00, 0x2C00, 
	0x2400, 0x2400, 0x2400, 0x2400, 0x2400, 0x2400, 0x2400, 0x2400, 0x1C00, 
	0x1C00, 0x1C00, 0x1C00, 0x1C00, 0x1C00, 0x1C00, 0x1C00, 0x1400, 0x1400, 
	0x1400, 0x1400, 0x1400, 0x1400, 0x1400, 0x1400, 0x0C00, 0x0C00, 0x0C00, 
	0x0C00, 0x0C00, 0x0C00, 0x0C00, 0x0C00, 0x0400, 0x0400, 0x0400, 0x0400, 
	0x0400, 0x0400, 0x0400, 0x0400, 0x0400, 0x0400, 0x0400, 0x0400, 0x0400, 
	0x0400, 0x0400, 0x0401, 0x0401, 0x0401, 0x0401, 0x0401, 0x0401, 0x0401, 
	0x0401, 0x0402, 0x0402, 0x0402, 0x0402, 0x0402, 0x0402, 0x0402, 0x0402, 
	0x0403, 0x0403, 0x0403, 0x0403, 0x0403, 0x0403, 0x0403, 0x0403, 0x0404, 
	0x0404, 0x0404, 0x0404, 0x0404, 0x0404, 0x0404, 0x0404, 0x0405, 0x0405, 
	0x0405, 0x0405, 0x0405, 0x0405, 0x0405, 0x0405, 0x0406, 0x0406, 0x0406, 
	0x0406, 0x0406, 0x0406, 0x0406, 0x0406, 0x0407, 0x0407, 0x0407, 0x0407, 
	0x0407, 0x0407, 0x0407, 0x0407, 0x0408, 0x0408, 0x0408, 0x0408, 0x0408, 
	0x0408, 0x0408, 0x0408, 0x0409, 0x0409, 0x0409, 0x0409, 0x0409, 0x0409, 
	0x0409, 0x0409, 0x040A, 0x040A, 0x040A, 0x040A, 0x040A, 0x040A, 0x040A, 
	0x040A, 0x040B, 0x040B, 0x040B, 0x040B, 0x040B, 0x040B, 0x040B, 0x040B, 
	0x040C, 0x040C, 0x040C, 0x040C, 0x040C, 0x040C, 0x040C, 0x040C, 0x040D, 
	0x040D, 0x040D, 0x040D, 0x040D, 0x040D, 0x040D, 0x040D, 0x040E, 0x040E, 
	0x040E, 0x040E, 0x040E, 0x040E, 0x040E, 0x040E, 0x040F, 0x040F, 0x040F, 
	0x040F, 0x040F, 0x040F, 0x040F, 0x040F, 0x0410, 0x03F0, 0x03F0, 0x03F0, 
	0x03F0, 0x03D0, 0x03D0, 0x03D0, 0x03D0, 0x03B0, 0x03B0, 0x03B0, 0x03B0, 
	0x0390, 0x0390, 0x0390, 0x0390, 0x0370, 0x0370, 0x0370, 0x0370, 0x0350, 
	0x0350, 0x0350, 0x0350, 0x0330, 0x0330, 0x0330, 0x0330, 0x0310, 0x0310, 
	0x0310, 0x0310, 0x02F0, 0x02F0, 0x02F0, 0x02F0, 0x02D0, 0x02D0, 0x02D0, 
	0x02D0, 0x02B0, 0x02B0, 0x02B0, 0x02B0, 0x0290, 0x0290, 0x0290, 0x0290, 
	0x0270, 0x0270, 0x0270, 0x0270, 0x0250, 0x0250, 0x0250, 0x0250, 0x0230, 
	0x0230, 0x0230, 0x0230, 0x0210, 0x0210, 0x0210, 0x0210, 0x01F0, 0x01F0, 
	0x01F0, 0x01F0, 0x01D0, 0x01D0, 0x01D0, 0x01D0, 0x01B0, 0x01B0, 0x01B0, 
	0x01B0, 0x0190, 0x0190, 0x0190, 0x0190, 0x0170, 0x0170, 0x0170, 0x0170, 
	0x0150, 0x0150, 0x0150, 0x0150, 0x0130, 0x0130, 0x0130, 0x0130, 0x0110, 
	0x0110, 0x0110, 0x0110, 0x00F0, 0x00F0, 0x00F0, 0x00F0, 0x00D0, 0x00D0, 
	0x00D0, 0x00D0, 0x00B0, 0x00B0, 0x00B0, 0x00B0, 0x0090, 0x0090, 0x0090, 
	0x0090, 0x0070, 0x0070, 0x0070, 0x0070, 0x0050, 0x0050, 0x0050, 0x0050, 
	0x0030, 0x0030, 0x0030, 0x0030, 0x0010, 0x0010, 0x0010, 0x0010, 0x0010, 
	0x0010, 0x0010, 0x0010, 0x0010, 0x0010, 0x0010, 0x0810, 0x0810, 0x0810, 
	0x0810, 0x0810, 0x0810, 0x0810, 0x0810, 0x1010, 0x1010, 0x1010, 0x1010, 
	0x1010, 0x1010, 0x1010, 0x1010, 0x1810, 0x1810, 0x1810, 0x1810, 0x1810, 
	0x1810, 0x1810, 0x1810, 0x2010, 0x2010, 0x2010, 0x2010, 0x2010, 0x2010, 
	0x2010, 0x2010, 0x2810, 0x2810, 0x2810, 0x2810, 0x2810, 0x2810, 0x2810, 
	0x2810, 0x3010, 0x3010, 0x3010, 0x3010, 0x3010, 0x3010, 0x3010, 0x3010, 
	0x3810, 0x3810, 0x3810, 0x3810, 0x3810, 0x3810, 0x3810, 0x3810, 0x4010, 
	0x4010, 0x4010, 0x4010, 0x4010, 0x4010, 0x4010, 0x4010, 0x4810, 0x4810, 
	0x4810, 0x4810, 0x4810, 0x4810, 0x4810, 0x4810, 0x5010, 0x5010, 0x5010, 
	0x5010, 0x5010, 0x5010, 0x5010, 0x5010, 0x5810, 0x5810, 0x5810, 0x5810, 
	0x5810, 0x5810, 0x5810, 0x5810, 0x6010, 0x6010, 0x6010, 0x6010, 0x6010, 
	0x6010, 0x6010, 0x6010, 0x6810, 0x6810, 0x6810, 0x6810, 0x6810, 0x6810, 
	0x6810, 0x6810, 0x7010, 0x7010, 0x7010, 0x7010, 0x7010, 0x7010, 0x7010, 
	0x7010, 0x7810, 0x7810, 0x7810, 0x7810, 0x7810, 0x7810, 0x7810, 0x7810, 
	0x8010, 0x800F, 0x800F, 0x800F, 0x800F, 0x800F, 0x800F, 0x800F, 0x800F, 
	0x800E, 0x800E, 0x800E, 0x800E, 0x800E, 0x800E, 0x800E, 0x800E, 0x800D, 
	0x800D, 0x800D, 0x800D, 0x800D, 0x800D, 0x800D, 0x800D, 0x800C, 0x800C, 
	0x800C, 0x800C, 0x800C, 0x800C, 0x800C, 0x800C, 0x800B, 0x800B, 0x800B, 
	0x800B, 0x800B, 0x800B, 0x800B, 0x800B, 0x800A, 0x800A, 0x800A, 0x800A, 
	0x800A, 0x800A, 0x800A, 0x800A, 0x8009, 0x8009, 0x8009, 0x8009, 0x8009, 
	0x8009, 0x8009, 0x8009, 0x8008, 0x8008, 0x8008, 0x8008, 0x8008, 0x8008, 
	0x8008, 0x8008, 0x8007, 0x8007, 0x8007, 0x8007, 0x8007, 0x8007, 0x8007, 
	0x8007, 0x8006, 0x8006, 0x8006, 0x8006, 0x8006, 0x8006, 0x8006, 0x8006, 
	0x8005, 0x8005, 0x8005, 0x8005, 0x8005, 0x8005, 0x8005, 0x8005, 0x8004, 
	0x8004, 0x8004, 0x8004, 0x8004, 0x8004, 0x8004, 0x8004, 0x8003, 0x8003, 
	0x8003, 0x8003, 0x8003, 0x8003, 0x8003, 0x8003, 0x8002, 0x8002, 0x8002, 
	0x8002, 0x8002, 0x8002, 0x8002, 0x8002, 0x8001, 0x8001, 0x8001, 0x8001, 
	0x8001, 0x8001, 0x8001, 0x8001, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 
	0x8000, 0x8000, 0x8000
};
