/*
 * BubsyMOD source code - textout.c
 * This application is open source and can be freely distributed
 * and modified, just leave credits to 8bitbubsy and mukunda.
 *
 * audio_mixer.c written by mukunda and 8bitbubsy
 * bubsymod.c written by 8bitbubsy
 * pattern_viewer.c written by 8bitbubsy
 * protracker_loader.c written by 8bitbubsy
 * protracker_sequencer.c written by mukunda and 8bitbubsy
 * sample_viewer.c written by 8bitbubsy
 * textout.c written by 8bitbubsy
 * volume.c written by 8bitbubsy
 *
 */

#include <SDL/SDL.h>
#include "player_font.h"

void textOut(SDL_Surface *dst, int putX, int putY, const char *text, unsigned short fontColor, int use_bg, unsigned short backColor)
{
	unsigned short *dst_buf = (unsigned short *)dst->pixels;

	int i, x, y;
	for (i = 0; text[i] != 0; i++)
	{
		int xCalcPos  = (i * FONT_CHAR_WIDTH) + putX;
		int xCalcPos2 = FONT_CHAR_WIDTH * (text[i] - ' ');

		for (y = 0; y < FONT_CHAR_HEIGHT; ++y)
		{
			int yCalcPos  = dst->w * (putY + y);
			int yCalcPos2 = y * FONT_BITMAP_WIDTH;

			for (x = 0; x < FONT_CHAR_WIDTH; ++x)
			{
				int buffOffset = yCalcPos  + xCalcPos  + x;
				int fontOffset = yCalcPos2 + xCalcPos2 + x;

				if (__bitmapFont[fontOffset])
					dst_buf[buffOffset] = fontColor; /* foreground */
				else if (use_bg == 1)
					dst_buf[buffOffset] = backColor; /* background */
			}
		}
	}

	return;
}
