/*
 * BubsyMOD source code - volume.c
 * This application is open source and can be freely distributed
 * and modified, just leave credits to 8bitbubsy and mukunda.
 *
 * audio_mixer.c written by mukunda and 8bitbubsy
 * bubsymod.c written by 8bitbubsy
 * pattern_viewer.c written by 8bitbubsy
 * protracker_loader.c written by 8bitbubsy
 * protracker_sequencer.c written by mukunda and 8bitbubsy
 * sample_viewer.c written by 8bitbubsy
 * textout.c written by 8bitbubsy
 * volume.c written by 8bitbubsy
 *
 */

#include <linux/soundcard.h>
#include <sys/ioctl.h>
#include <fcntl.h>
#include <unistd.h>

unsigned char getVolume()
{
	int vol;

	int mixerdev = open("/dev/mixer", O_WRONLY);
	ioctl(mixerdev, SOUND_MIXER_READ_VOLUME, &vol);
	close(mixerdev);

	return (vol & 0xFF); /* get left channel vol */
}

void setVolume(unsigned char volume)
{
	int vol = volume | (volume << 8); /* set for both channels */

	int mixerdev = open("/dev/mixer", O_WRONLY);
	ioctl(mixerdev, SOUND_MIXER_WRITE_VOLUME, &vol);
	close(mixerdev);

	return;
}
